.386
.model	flat, stdcall
option	casemap:none

include	CustMsgbox.inc

ID_TIMER equ 5000

CustomMsgBox	PROTO :DWORD,:DWORD,:DWORD,:DWORD
TimerProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
msg1		db 'This customized message box will destroy itself after 5000 miliseconds',0
capt		db 'Hello!',0
btext		db 'Click here',0
flag		dd 0

.data?
hMboxHook	dd ?
pButtonText	dd ?

.code

start:

	invoke	CustomMsgBox,0,ADDR msg1,ADDR capt,ADDR btext
	invoke	ExitProcess,0

mboxCBTProc PROC nCode:DWORD,wParam:DWORD,lParam:DWORD

	cmp		nCode,0
	jb		exit
	cmp		nCode,HCBT_ACTIVATE
	jne		exit
	cmp		flag,0
	jnz		@f
	invoke	GetDlgItem,wParam,IDOK
	invoke	SetWindowText,eax,pButtonText
	invoke	SetTimer,wParam,ID_TIMER,5000,ADDR TimerProc
	mov		flag,1
@@:
	xor		eax,eax
	ret	

exit:

	invoke	CallNextHookEx,hMboxHook,nCode,wParam,lParam
	ret

mboxCBTProc ENDP

CustomMsgBox PROC hWnd:DWORD,message:DWORD,caption:DWORD,buttontext:DWORD

	mov		eax,buttontext
	mov		pButtonText,eax
	invoke	GetCurrentThreadId
	invoke	SetWindowsHookEx,WH_CBT,ADDR mboxCBTProc,NULL,eax
	mov		hMboxHook,eax
	invoke	MessageBox,0,message,caption,MB_OK
	invoke	UnhookWindowsHookEx,hMboxHook
	ret

CustomMsgBox ENDP

TimerProc PROC hWnd:DWORD,uMsg:DWORD,idEvent:DWORD,dwTime:DWORD

	invoke	DestroyWindow,hWnd
	ret

TimerProc ENDP


END start